window.handleOpenURL = function(url) {
    window.openString = url;
};

window.mobileVersion = "8";
window.openString="";
var ajax = {};
var ai = '';  // Advertiser ID
var lt = '';  // Limited tracking 

ajax.x = function ()
{
    if (typeof XMLHttpRequest !== 'undefined')
    {
        return new XMLHttpRequest();
    }
    var versions = [
        "MSXML2.XmlHttp.6.0",
        "MSXML2.XmlHttp.5.0",
        "MSXML2.XmlHttp.4.0",
        "MSXML2.XmlHttp.3.0",
        "MSXML2.XmlHttp.2.0",
        "Microsoft.XmlHttp"];
    var xhr;
    for (var i = 0; i < versions.length; i++)
    {
        try
        {
            xhr = new ActiveXObject(versions[i]);
            break;
        } catch (e)
        {
        }
    }
    return xhr;
};
ajax.send = function (url, callback, method, data, async)
{
    if (async === undefined)
    {
        async = true;
    }
    var x = ajax.x();
    x.open(method, url, async);
    x.onreadystatechange = function ()
    {
        if (x.readyState == 4)
        {
            callback(x.responseText);
        }
    };
    if (method == 'POST')
    {
        x.setRequestHeader('Content-type', 'application/json');
    }
    x.send(data);
};

ajax.post = function (url, data, callback, async)
{
    data = JSON.stringify(data);
    ajax.send(url, callback, 'POST', data, async);
    return;
};

window.notLoadingTimeout = setTimeout(function(){
	
	document.getElementById("loadingdelayed").style.display='block';
	
},10000);

window.internetProblemDiv = document.getElementById('internetProblem');
window.loadingSectionDiv = document.getElementById('loadingSection');
window.mainFrameDiv = document.getElementById('mainFrame');


var app = {
	webSiteLoaded: false,
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    bindEvents: function() {
        window.addEventListener("message", app.onMessage, false);

        document.addEventListener('deviceready', app.onDeviceReady, false);

        document.addEventListener('offline', app.checkConnection, false);
        document.addEventListener('online', app.hideNetworkError, false);

        document.addEventListener("resume", app.onResume, false);
        document.addEventListener("pause", app.onPause, false);

        document.addEventListener('backbutton', app.onBackKeyDown, false);
    },

    // deviceready Event Handler
    onDeviceReady: function() {

        app.receivedEvent('deviceready');
        app.startFortraderApp();
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        console.log('Received Event: ' + id);
    },

    startFortraderApp: function(){
        try {
            app.sendFortraderTracking();
        } catch (err) {
            app.reportError("Failed to send fortrade tracking", "sendFortraderTracking", 0, 0, err);
        }

        try {
            app.checkInstallTracking();
        } catch (err) {
            app.reportError("Failed to late track android install", "checkInstallTracking", 0, 0, err);
        }
		if(window.MobileAccessibility){
			console.log('fix font size');
			window.MobileAccessibility.usePreferredTextZoom(false);
		}
        app.checkConnection();
    },

    checkConnection: function () {
		console.log('checking connection');
        var networkState = navigator.connection.type;
        console.log(networkState);

        if (networkState == Connection.NONE)
            app.showNetworkError();
        else
            app.hideNetworkError();
    },

    showNetworkError: function() {
        console.log('showing network error');
		app.hideAllDivs();
		internetProblemDiv.style.display='block';
    },

    hideNetworkError: function() {
		console.log('hiding network error');
		app.hideAllDivs();
		app.navigateIframe();
    },

    navigateIframe: function() {
		console.log('navigating iframe');
		loadingSectionDiv.style.display = 'block';
        clearTimeout(window.navTimer);
		window.navTimer = setTimeout(app.doNavigate, 350);
    },
	hideAllDivs: function(){
		document.getElementById('loadingdelayed').style.display='none';
		mainFrameDiv.style.display='none';
		loadingSectionDiv.style.display='none';
		internetProblemDiv.style.display='none';
	},
    doNavigate: function() {
        // DEBUG BUILD
		clearTimeout(window.notLoadingTimeout);
		window.notLoadingTimeout = setTimeout(function(){
			document.getElementById("loadingdelayed").style.display='block';			
		},10000);
		
        var url = siteConfig.domainName + '/?androidapp=true&platform=android&uniqueId=' + FtTrack.uniqueId + '&guid=' + FtTrack.guid + "&gclid=" + FtTrack.gclid + "&version="+ window.mobileVersion +"&aid=" + ai;

        if (FtTrack.token) {
            url = url + "&token=" + FtTrack.token + "&lang=" + FtTrack.appLang;
            FtTrack.removeToken();
        }

        if (window.openString)
            url = url + "&query=" + encodeURIComponent(window.openString);
		
		
		app.semiProLoaded();
		console.log(url);
		window.location.href=url;		
    },

    sendFortraderTracking: function() {
        console.log('tracking');

        var ti = '';  // Tracking Initialized
        var ts = '';  // Tracking Sent
        var ls = '';  // LogSent
        var n = '';   // Network
        var so = '';  // Sim Operator Name
        var no = '';  // Network Operator Name 
        var p = "";   // Phone

        try {
            FtTrack.getAdvInfo(function (v)
            {
                ai = v.id; lt = v.limitAdTracking;
                if (lt == true || lt == "true")
                    ai = "00000000-0000-0000-0000-000000000000";
            });
        } catch (err) { }

        try {
            FtTrack.getValue('TrackingInitialized', function(v){ti=v;});
            FtTrack.getValue('TrackingSent', function(v){ts=v;});
            FtTrack.getValue('LogSent', function(v){ls=v;});
        } catch (err) { }

        try {
            FtTrack.getNetInfo(function(v){n=v.network; so=v.simop; no=v.netop; p=v.phone; });
        } catch (err) { }

        setTimeout(function(){
            app.addPixel(siteConfig.domainName + "/server/downloads/trkdbop?op=deviceTracking" +
                '&platform=' + device.platform +
                //  '&uuid=' + device.uuid +
                '&uniqueId=' +  FtTrack.uniqueId +
                '&guid=' + FtTrack.guid +
                '&adid=' + ai +
                '&aid=' + ai +
                '&lt=' + lt +
                '&ti=' + ti +
                '&ts=' + ts +
                '&ls=' + ls +
                '&n=' + n +
                '&so=' + so +
                '&no=' + no +
                '&p=' + p +
                '&v=' + window.mobileVersion +
                '&rt=1');
        }, 150);
    },

    checkInstallTracking: function() {
        if (FtTrack.trackingInitialized == '') {
            console.log('App tracking not initialized');

            try {
                FtTrack.init();
            }
            catch (err) {
                app.reportError("Failed to init tracking", "checkInstallTracking", 0, 0, err);
            }

            setTimeout(function(){ app.checkInstallTracking(); }, 5000);
            return;
        }

        if (FtTrack.trackingSent == 'false')
        {
            console.log('Sending tracking');

            try {
                FtTrack.track("androidInstall", "", siteConfig.domainName, function (value) {
                    FtTrack.guid = value;

                    var trupdateurl = siteConfig.domainName + '/api/account/updatetrackingdata/' + value;
                    console.log('updating tracking: ' + trupdateurl);
                    app.addPixel(trupdateurl);
                });
            }
            catch (err) {
                app.reportError("Failed to track androidInstall", "checkInstallTracking", 0, 0, err);
            }
        }

        if (FtTrack.logSent == 'false')
        {
            try {
                app.addPixel(siteConfig.domainName + '/server/downloads/trkdbop?op=androidInstallLog' +
                    '&platform=' + device.platform +
                    '&uniqueId=' + FtTrack.uniqueId +
                    // '&uuid=' + device.uuid +
                    '&adid=' + ai +
                    '&aid=' + ai +
                    '&lt=' + lt +
                    '&aid=' + ai +
                    '&guid=' + FtTrack.guid +
                    '&version=' + window.mobileVersion +
                    '&rt=1' + FtTrack.chainTimes +
                    '&ftTrackTime=' + FtTrack.ftTrackTime);
                FtTrack.setValue('LogSent', 'true');
            }
            catch (err) {
                app.reportError("Failed to send install log", "checkInstallTracking", 0, 0, err);
            }
        }
    },

    onResume: function () {

    },

    onPause: function () {
 
    },
	
	semiProLoaded: function(){
		app.hideAllDivs();
		mainFrameDiv.style.display='block';
		clearTimeout(notLoadingTimeout);
	},
    onMessage: function (event) {
		console.log(JSON.stringify(event));
        var eventName = event.data.eventName;
        var eventData = event.data.eventData;
		console.log('on message ' + event.data.eventName);
        try {
			
			if(eventName == "ExecuteCustomEvent"){
				eval(eventData);
				return;
			}			
			
			if(eventName == "SemiPro-Loaded"){
				app.semiProLoaded();
			}
			
			if(eventName == "SemiPro-ConnectionProblem"){
				app.showNetworkError();
			}
        }
        catch (err) {
            app.reportError("Failed to handle message: " + eventName, "onMessage", 0, 0, err);
        }

    },
    addPixel: function (url) {
        var imgTmp = document.createElement('img');
        imgTmp.style.display = 'none';
        imgTmp.src = url;
        document.getElementsByTagName('body')[0].appendChild(imgTmp);
    },

    getCookie: function(cname) {
        var name = cname + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1);
            if (c.indexOf(name) == 0) return c.substring(name.length, c.length);
        }
        return "";
    },

    onBackKeyDown: function () {

    },

    reportError: function (message, source, lineno, colno, error) {
        if (typeof window.errorsCaching == 'undefined')
            window.errorsCaching = {};

        if (window.errorsCaching[lineno + "-" + colno])
            return;

        window.errorsCaching[lineno + "-" + colno] = true;

        var journalRecord = {
            Action: "Cordova JS Errors"+ siteConfig.version,
            Origin: "SEMI.AndroidApp",
            Details: [message, source, lineno, colno],
            Tags: ["platform:android"],
            Exception: error.toString(),
            LogLevel: "Error"
        };
        console.log(journalRecord);
        ajax.post(siteConfig.domainName + "/api/journal/writetojournal", journalRecord, function () { console.log("written to journal"); }, true);
        return true;
    }
};

window.onerror = function (message, source, lineno, colno, error)
{
    app.reportError(message, source, lineno, colno, error);
};

app.initialize();