cordova.define("cordova-plugin-traderapp-tracking.TraderAppTracking", function(require, exports, module) {
    var exec = require('cordova/exec'),
        channel = require('cordova/channel'),
        cordova = require('cordova');

    var fTrackingPlugin = function () {
        this.guid = "";
        this.gclid = "";
		this.uniqueId = "";
        this.referrer = "";
        this.trackingUrl = "";
        this.trackingSent = "";
        this.logSent = "";
        this.chainTimes = "";
        this.ftTrackTime = "";
        this.trackingInitialized = "";
        this.token = "";
        this.appLang = "";
        this.version = "";

        var me = this;

        channel.onCordovaReady.subscribe(function () {
            me.getInfo(function (info) {
                me.guid = info.guid;
                me.gclid = info.gclid;
				me.uniqueId = info.uniqueId;
                me.referrer = info.referrer;
                me.trackingUrl = info.trackingUrl;
                me.trackingSent = info.trackingSent;
                me.trackingInitialized = info.trackingInitialized;
                me.logSent = info.logSent;
                me.chainTimes = info.chainTimes;
                me.ftTrackTime = info.ftTrackTime;
                me.token = info.token;
                me.appLang = info.appLang;
                me.version = info.version;
            });
        });
    };

    fTrackingPlugin.prototype.init = function (successCallback, errorCallback) {
        var me = this;

        me.getInfo(function (info) {
            me.guid = info.guid;
            me.gclid = info.gclid;
			me.uniqueId = info.uniqueId;
            me.referrer = info.referrer;
            me.trackingUrl = info.trackingUrl;
            me.trackingSent = info.trackingSent;
            me.trackingInitialized = info.trackingInitialized;
            me.logSent = info.logSent;
            me.chainTimes = info.chainTimes;
            me.ftTrackTime = info.ftTrackTime;
            me.token = info.token;
            me.appLang = info.appLang;
            me.version = info.version;
        });
    }

    fTrackingPlugin.prototype.getValue = function (name, successCallback, errorCallback) {
        cordova.exec(successCallback, errorCallback, "TraderAppTracking", "getValue", [name]);
    }

    fTrackingPlugin.prototype.setValue = function (name, value, successCallback, errorCallback) {
        cordova.exec(successCallback, errorCallback, "TraderAppTracking", "setValue", [name, value]);
    }

    fTrackingPlugin.prototype.track = function (trackingOp, prms, trksrv, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, "TraderAppTracking", "track", [trackingOp, prms, trksrv]);
    }

    fTrackingPlugin.prototype.getInfo = function (successCallback, errorCallback) {
        cordova.exec(successCallback, errorCallback, "TraderAppTracking", "getInfo", []);
    }

    fTrackingPlugin.prototype.getAdvInfo = function (successCallback, errorCallback) {
        cordova.exec(successCallback, errorCallback, "TraderAppTracking", "getAdvInfo", []);
    }

    fTrackingPlugin.prototype.getNetInfo = function (successCallback, errorCallback) {
        cordova.exec(successCallback, errorCallback, "TraderAppTracking", "getNetInfo", []);
    }

    fTrackingPlugin.prototype.removeToken = function (successCallback, errorCallback) {
        cordova.exec(successCallback, errorCallback, "TraderAppTracking", "removeToken", []);
    }

    module.exports = new fTrackingPlugin();
});
